#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <string.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"

#define SCREEN_WIDTH    640
#define SCREEN_HEIGHT   480

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Langton's ant 3", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0));

    int     x = SCREEN_WIDTH / 2;
    int     y = SCREEN_HEIGHT / 2;
    int     dir = 0; // direction 0=up, 1=right, 2=down, 3=left
    int     world[SCREEN_WIDTH][SCREEN_HEIGHT];

    char    rule[] = "RLR";
//    char    rule[] = "RLLR";
//    char    rule[] = "RLRRRRLLLR";
//    char    rule[] = "RRLLLRLLLRRR";
    int     nbColors = strlen(rule);
    Color*  palette;

    // init world
    for (int yy = 0; yy < SCREEN_HEIGHT; yy++)
        for (int xx = 0; xx < SCREEN_WIDTH; xx++)
            world[xx][yy] = 0;

    // init palette
    srand(time(NULL));
    palette = new Color[nbColors];
    palette[0] = Color(0, 0, 0);

    for (int i = 1; i < nbColors; i++)
    {
        palette[i] = Color(rand() % 256,
                           rand() % 256,
                           rand() % 256);
    }

    // wait till the end
    while (sys.isQuitRequested() == false)
    {
        // if we are on the screen
        if (x >= 0 && x < SCREEN_WIDTH &&
            y >= 0 && y < SCREEN_HEIGHT)
        {
            // get current color
            int c = world[x][y];

            // turn
            if (rule[c] == 'R')
            {
                dir = (dir + 1) % 4; // turn right
            }
            else
            {
                dir = (dir - 1 + 4) % 4; // turn left
            }

            // change color
            c = (c + 1) % nbColors;
            world[x][y] = c;
            gfx.setPixel(x, y, palette[c]);

            // move forward
            if (dir == 0)
            {
                y--; // up
            }
            else if (dir == 1)
            {
                x++; // right
            }
            else if (dir == 2)
            {
                y++; // down
            }
            else
            {
                x--; // left
            }
        }

        sys.processEvents();
        gfx.render();
    }

    delete[] palette;
    gfx.quit();

    return EXIT_SUCCESS;
}
